/** Licensed Materials - Property of IBM, 5724-E76 and 5724-E77, (C) Copyright IBM Corp. 2009 - All Rights reserved.  **/

if(!dojo._hasResource["ibm.portal.search.Enhanced.widgets.searchBox"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["ibm.portal.search.Enhanced.widgets.searchBox"] = true;
dojo.require("dojo.parser");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("ibm.portal.search.widgets.common");
dojo.require("com.ibm.portal.xslt");
dojo.require("com.ibm.portal.xpath");
dojo.provide("ibm.portal.search.Enhanced.widgets.searchBox");

ibm.portal.search.util.getNodes = function(/*DomNode*/ xmlDoc, /*String*/ nodePath) {
	return com.ibm.portal.xpath.evaluateXPath(nodePath, 
		xmlDoc, ibm.portal.search.util.xmlNamespaces);
};

dojo.declare(
   "ibm.portal.search.Enhanced.widgets.ScopeSearchWidget",
   [dijit._Widget, dijit._Templated, dijit._Container],
   {
   	//summary:
	//	a widget which allows the user to choose a scope and enter query, in order to perform search.
	
	//define template by external file
	templateString:"<form dojoAttachPoint=\"queryForm\" action=\"${submitUrl}\" dojoAttachEvent=\"onsubmit:submitQueryForm\" \n\tmethod=\"get\" name=\"searchQueryForm\" class=\"lotusSearch\"\n\t><table class=\"lotusLayout\" cellspacing=\"0\" summary=\"layout table\"\n\t\t><tr><td style=\"display: none\" dojoAttachPoint=\"scopeSelectionNode\"><a href=\"javascript:;\" class=\"lotusScope\" title=\"${resourceBundle.scopeButtonTooltip}\" dojoAttachPoint=\"scopeNode\" dojoAttachEvent=\"onclick:openMenu\"\n\t\t\t\t><img class=\"lotusIcon lotusHidden\" dojoAttachPoint=\"scopeIconNode\" alt=\"\" /\n\t\t\t\t><span dojoAttachPoint=\"scopeNameNode\"></span\n\t\t\t\t><span class=\"lotusAltText\">&#x25bc;</span\n\t\t\t></a></td><td\n\t\t><input type=\"hidden\" dojoAttachPoint=\"scope\" name=\"scope\"/\n\t\t><input type=\"hidden\" name=\"sourceContentNode\" value=\"${sourceContentNode}\"/\n\t\t><label class=\"lotusHidden\" for=\"${id}searchInput\">${resourceBundle.searchInstruction}</label\n\t\t><input type=\"text\"\n\t\t\tdojoAttachPoint=\"query\"\n\t\t\tdojoAttachEvent=\"onfocus:onTextFocus, onblur:onTextBlur\"\n\t\t\tname=\"query\"\n\t\t\tid=\"${id}searchInput\"\n\t\t\tclass=\"${disabledTextClass} lotusText\" \n\t\t\tvalue=\"${resourceBundle.searchInstruction}\"/\n\t\t></td><td><span class=\"lotusBtnImg\"\n\t\t><input class=\"lotusSearchButton\" type=\"image\" alt=\"${resourceBundle.searchInstruction}\" title=\"${resourceBundle.searchAltText}\" src=\"${blankIcon}\"/\n\t\t><span class=\"lotusAltText\">${resourceBundle.searchAltText}</span></span></td></tr></table\n></form>\n",
	
	//widgetsInTemplate: Boolean
	//	override dijit._Templated's default value
	widgetsInTemplate: true,
	
	//submitUrl: String
	//	the URL to whom the search form will be submitted
	submitUrl: '',
	
	//sourceContentNode: String
	//	contains the id of the current content node
	sourceContentNode: '',
	
	//disabledTextClass: String
	//	The CSS class of an empty query box, which displays the name of the search scope
	disabledTextClass: 'lotusInactive',
	
	//contextualScopes: Array
	//	an array of contextual scopes, added by the user
	contextualScopes: null,
	
	//searchLinks: Array
	//	an array of additional search links for the search menu, added by the user
	searchLinks: null,
	
	//menuTTL: number
	//	The time (in milliseconds) to cache the search menu in the browser
	menuTTL: 1000 * 60 * 15,//15 minutes

	//resourceBundle: Object
	//	A map between keys and translated strings
	resourceBundle: null,
	
	scopes: null,
	
	emptyScope: {id: "", label: "", description: "", icon: ""},
	
	searchFeedUrl: null,
	
	timeStamp: null,
	
	displayScopes: true,
	
	//override dijit._Widget's method
	postMixInProperties: function() {
		this.blankIcon = dojo.moduleUrl("dojo.resources", "blank.gif").toString();
	},
	
	//override dijit._Widget's method
	startup: function () {
		dojo.subscribe(ibm.portal.search.scope.SCOPE_SELECTED_TOPIC, this, 'scopeSelected');
		dojo.subscribe(ibm.portal.search.NEW_QUERY_TOPIC, this, 'newQuery');
		dojo.subscribe(ibm.portal.search.scope.ADD_SCOPE_TOPIC, this, 'addContextualScope');
		dojo.subscribe(ibm.portal.search.scope.SUBMIT_SCOPE_TOPIC, this, 'submitScope');
	},
	
	//override dijit._Widget's method
	postCreate: function(){
		this.scopeService = ibm.portal.search.util.getServiceUrl(this.searchFeedUrl, 'scopes', {
			locale: djConfig.locale,
			customLinks: true,
			timeStamp: this.timeStamp
		});
		this.retrieveScopes();
	},
	
	//summary:
	//	this function will be called following a 'SCOPE_SELECTED' event
	//newScope: ibm.portal.search.scope.Scope
	//	the scope object that was selected by the user
	scopeSelected: function(/*ibm.portal.search.scope.Scope*/ newScope) {
		if (djConfig.isDebug) {
			console.debug("scopeSelected");
		}
		this.selectedScope = newScope;
		this.scopeIconNode.src = newScope.icon;
		dojo.toggleClass(this.scopeIconNode, "lotusHidden", (newScope.icon == null));		
		this.scopeNameNode.innerHTML = newScope.label;
		this.scope.value = newScope.id;
		this.closeMenu();
	},
	
	//summary:
	//	add a contextual scope to the search menu
	//scope: ibm.portal.search.scope.Scope
	//	the scope object
	//isDefault: Boolean
	//	Optional (default is false). Add this scope as the currently selected scope.
	addContextualScope: function(/*ibm.portal.search.scope.Scope*/ scope, /*Boolean?*/ isDefault) {
		if (djConfig.isDebug) {
			console.debug("addContextualScope");
		}
		if (this.contextualScopes == null) {
			this.contextualScopes = [];
		}
		if (isDefault) {
			this.scopeSelected(scope);
		} 
		this.contextualScopes.push(scope);
	},
	
	//summary:
	//	this function will be called following a 'NEW_QUERY' event
	//newQuery: ibm.portal.search.Query
	//	the query that was submitted
	newQuery: function(/*ibm.portal.search.Query*/ newQuery) {
		if (djConfig.isDebug) {
			console.debug("ScopeSearchWidget: newQuery");
		}
		this.query.value = newQuery.text;
		if (dojo.hasClass(this.query, this.disabledTextClass)) {
			dojo.removeClass(this.query, this.disabledTextClass);
		}
		this.onBlur();
	},
	//summary:
	//	this function retrieves the scopes from the server, or from browser cache
	retrieveScopes: function() {
		dojo.xhrGet({
			url: this.scopeService,
			load: dojo.hitch(this, "handleScopes"),
			error: dojo.hitch(this, "handleScopeError"),
			handleAs: 'text'
		});
	},
	
	//summary:
	//	this function handles the scope information retrieved from the server
	handleScopes: function(response, ioArgs) {
		var scopesXml = com.ibm.portal.xslt.loadXmlString(response);//required because of IE issues
		var feed = ibm.portal.search.util.getNodes(scopesXml, "/atom:feed")[0];
		var entries = ibm.portal.search.util.getNodes(feed, "atom:entry");
		this.scopes = [];
		
		for (var i = 0; i < entries.length; i++) {
			var id = ibm.portal.search.util.getXpathValue(entries[i], "atom:id");
			var label = ibm.portal.search.util.getXpathValue(entries[i], "atom:title");			
			var link = ibm.portal.search.util.getXpathValue(entries[i], "atom:link/@href");
			var description = ibm.portal.search.util.getXpathValue(entries[i], "atom:summary");
			var icon = ibm.portal.search.util.getXpathValue(entries[i], "opensearch:image");
			var scope = new ibm.portal.search.scope.Scope(label, description, icon, id);
			if (link != null) {
				scope.link = link;
			}
			this.scopes.push(scope);
		}
		
		if (this.scopes.length == 0) {
			this.scopes.push(this.emptyScope);
		}
		if (this.scopes.length > 1 && this.displayScopes) {
			dojo.style(this.scopeSelectionNode, "display", "");
		}
		
		var firstScope = this.scopes[0];
		this.scopeSelected(new ibm.portal.search.scope.Scope(firstScope.label, 
					firstScope.description, firstScope.icon, firstScope.id));		
	},
	
	//summary:
	//	this function handles an error when retrieving scopes from the server
	handleScopeError: function(response, ioArgs) {
		this.scopes = [this.emptyScope];
	},
	
	//summary:
	//	this menu items for contextual scopes
	addContextualScopesMenuItems: function() {
		if (this.contextualScopes == null) {
			return;//no need for special search links
		}
		for (var i = 0; i < this.contextualScopes.length; i++) {
			this.addScopeMenuItem(this.contextualScopes[i]);
		}
		this.scopeMenu.addChild(new dijit.MenuSeparator({}));
	},
	
	//summary:
	//	this function adds a single scope item to the menu
	addScopeMenuItem: function(scopeItem) {
		var menuItemParams = {
			obj: scopeItem, 
			label: scopeItem.label,
			parentMenu: this.scopeMenu,
			scopeSearchWidget: this
		}			
		if (scopeItem.icon != null) {
			menuItemParams._blankGif = scopeItem.icon;
		}
		var menuItem = new dijit.MenuItem(menuItemParams);
		this.scopeMenu.addChild(menuItem);
		if (scopeItem.description != null) {
			menuItem.iconNode.title = scopeItem.description;
		}
	},
	
	//summary:
	//	this function adds the scope items to the menu
	addScopeMenuItems: function() {
		if (djConfig.isDebug) {
			console.debug("addScopeMenuItems");
		}
		var scopeItems = this.scopes;
		
		var firstCustomLink = true;
		for (var i = 0; i < scopeItems.length; i++) {
			var scopeItem = scopeItems[i];
			if (scopeItem.link != null && firstCustomLink) {//this is the first custom link
				this.scopeMenu.addChild(new dijit.MenuSeparator({}));
				firstCustomLink = false;
			}
			this.addScopeMenuItem(scopeItem);
		}
	},
	
	//summary:
	//	get the text from the query box.
	getQueryText: function () {		
		return this.query.value;
	},
	
	//summary:
	//	this function is called when the search form is submitted
	submitQueryForm: function(event) {
		if (djConfig.isDebug) {
			console.debug("submitQueryForm");
		}
		var queryText = this.getQueryText();		
		if (dojo.hasClass(this.query, this.disabledTextClass)) {
			this.query.value = "";
		}
		
		this.scope.value = encodeURIComponent(dojo.toJson(this.selectedScope));
		return true;
	},
	//summary:
	//	update scope and query parameters and submits the search form
	submitScope: function(/*ibm.portal.search.scope.Scope*/ scope, /*String?*/ query) {
		if (djConfig.isDebug) {
			console.debug("submitScope");
		}
		
		if (scope != ibm.portal.search.scope.SELECTED_SCOPE) {
			this.queryForm.method.value = 'POST';
			this.scope.value = encodeURIComponent(dojo.toJson(scope));
		} else {
			this.scope.value = encodeURIComponent(dojo.toJson(this.selectedScope));
		}
		
		this.query.value = (query != null)? query: '';
		if (scope.query != null) {
			this.query.value = this.query.value + " " + scope.query;
		}
		
		this.queryForm.submit();
	},
	//summary:
	//	this function is called when the user focuses on the search input field
	onTextFocus: function() {
		if (dojo.hasClass(this.query, this.disabledTextClass)) {
			this.query.value = "";
			dojo.removeClass(this.query, this.disabledTextClass);
		}
	},
	//summary:
	//	this function is called when the user removed focus from the search input field
	onTextBlur: function() {
		if (this.query.value == "") {
			dojo.addClass(this.query, this.disabledTextClass);
			this.query.value = this.resourceBundle.searchInstruction;			
		}
	},
	
	selectOption: function(menuItem) {
		if (menuItem.obj.link != null) {//this is a custom link
			var queryText = menuItem.scopeSearchWidget.getQueryText();
			queryText = queryText.replace(/"/g, "\\\"");
			var newWindow = window.open();
			//The delayed focus was added to solve a problem in IE
			//The location is set only after the focus to avoid cross-frame-scripting issues
			newWindow.setTimeout("focus(); document.location = \"" + menuItem.obj.link + queryText + "\";", 100);
			this.scopeSearchWidget.closeMenu();
		} else {
			dojo.publish(ibm.portal.search.scope.SCOPE_SELECTED_TOPIC, [menuItem.obj])
			this.query.focus();
		}
	},
	
	getScopeMenu: function() {
		if (this.scopeMenu != null) {
			return this.scopeMenu;
		}
		this.scopeMenu = new dijit.Menu({
			onItemClick: dojo.hitch(this, "selectOption")
		});
		this.connect(this.scopeMenu, '_onBlur', 'closeMenu');
			
		this.addContextualScopesMenuItems();
		this.addScopeMenuItems();
	
		return this.scopeMenu;
	},
	
	openMenu: function(evt) {
		var menu = this.getScopeMenu();
		
		dijit.popup.open({
		    popup: menu,
		    around: this.scopeNode,
		    //Specify how the popup should align with the button that was clicked
		    orient: (dojo._isBodyLtr() ? {'BL':'TL', 'BR':'TR'} : 
				      {'BR':'TR', 'BL':'TL'}),
		    onExecute: function(){ 
		    },
		    onCancel : dojo.hitch(this,function() {
			dijit.popup.close(menu);
			dijit.focus(this.scopeNode);
		    }),
		    onClose: function() {
		    }
		});
		
		//Must focus here or else clicking off won't blur and won't cause it to close
		menu.focus();
		
		dojo.stopEvent(evt);
    },
    
	closeMenu: function() {
		if (this.scopeMenu) {
		    dijit.popup.close(this.scopeMenu);
		    //fix problem where previouly selected scopes remain marked as selected.
		    var children = this.scopeMenu.getChildren();
		    for (var i = 0; i < children.length; i++) {
			dojo.removeClass(children[i].domNode, 'dijitMenuItemHover');
		    }
		}
	}
});

}
