<!-- Copyright IBM Corp. 2007  All Rights Reserved.                    -->
	
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:atom="http://www.w3.org/2005/Atom" 
	xmlns:opensearch="http://a9.com/-/spec/opensearch/1.1/"	
	>
<xsl:output method="html" version="1.0" encoding="UTF-8" indent="yes" omit-xml-declaration="yes"/>

<xsl:param name="contextRoot"></xsl:param>
<xsl:param name="isRTL"></xsl:param>
<xsl:param name="relevanceHeader"></xsl:param>
<xsl:param name="titleHeader"></xsl:param>
<xsl:param name="personHeader"></xsl:param>
<xsl:param name="dateHeader"></xsl:param>
<xsl:param name="showingResultsMessage"></xsl:param>
<xsl:param name="firstPageText"></xsl:param>
<xsl:param name="prevPageText"></xsl:param>
<xsl:param name="nextPageText"></xsl:param>
<xsl:param name="firstPageIcon"><xsl:value-of select="$contextRoot"/>/themes/html/Buttons_First<xsl:value-of select="$isRTL"/>.gif</xsl:param>
<xsl:param name="prevPageIcon"><xsl:value-of select="$contextRoot"/>/themes/html/Buttons_Left<xsl:value-of select="$isRTL"/>.gif</xsl:param>
<xsl:param name="nextPageIcon"><xsl:value-of select="$contextRoot"/>/themes/html/Buttons_Right<xsl:value-of select="$isRTL"/>.gif</xsl:param>
<xsl:param name="scoreHighestIcon"><xsl:value-of select="$contextRoot"/>/themes/dojo/portal_dojo/ibm/portal/search/icons/score_highest.gif</xsl:param>
<xsl:param name="scoreHighest"></xsl:param>
<xsl:param name="scoreHighIcon"><xsl:value-of select="$contextRoot"/>/themes/dojo/portal_dojo/ibm/portal/search/icons/score_high.gif</xsl:param>
<xsl:param name="scoreHigh"></xsl:param>
<xsl:param name="scoreMediumIcon"><xsl:value-of select="$contextRoot"/>/themes/dojo/portal_dojo/ibm/portal/search/icons/score_medium.gif</xsl:param>
<xsl:param name="scoreMedium"></xsl:param>
<xsl:param name="scoreLowIcon"><xsl:value-of select="$contextRoot"/>/themes/dojo/portal_dojo/ibm/portal/search/icons/score_low.gif</xsl:param>
<xsl:param name="scoreLow"></xsl:param>
<xsl:param name="scoreLowestIcon"><xsl:value-of select="$contextRoot"/>/themes/dojo/portal_dojo/ibm/portal/search/icons/score_lowest.gif</xsl:param>
<xsl:param name="scoreLowest"></xsl:param>
<xsl:param name="dotIcon"><xsl:value-of select="$contextRoot"/>/themes/html/psw/wcl/images/o.gif</xsl:param>
<xsl:param name="numOfResults"></xsl:param>

<xsl:template match="/atom:feed">
<xsl:if test="opensearch:totalResults &gt; 0">
<table width="100%" cellspacing="0" cellpadding="0" border="1" class="wpsPagingTable" summary="${searchResultsTableDescription}">
<tbody>
	<tr>
		<td class="wpsPagingTableHeader">
			<xsl:call-template name="tableHeader">
				<xsl:with-param name="startClass">wpsPagingTableHeaderStart</xsl:with-param>
				<xsl:with-param name="middleClass">wpsPagingTableHeaderMiddle</xsl:with-param>
				<xsl:with-param name="endClass">wpsPagingTableHeaderEnd</xsl:with-param>
				<xsl:with-param name="displayItemsPerPage">false</xsl:with-param>
			</xsl:call-template>
		</td>
	</tr>
	<tr>
		<td class="wpsPagingTableBody">
			<table width="100%" cellspacing="0" cellpadding="0" border="0" class="wpsTable">
				<thead>
					<tr class="wpsTableHead">
						<th nowrap="nowrap" class="wpsTableHeadStart"><xsl:value-of select="$relevanceHeader"/></th>
						<th nowrap="nowrap" class="wpsTableHeadMiddle"><xsl:value-of select="$titleHeader"/></th>
						<th nowrap="nowrap" class="wpsTableHeadMiddle"><xsl:value-of select="$personHeader"/></th>
						<th nowrap="nowrap" class="wpsTableHeadEnd"><xsl:value-of select="$dateHeader"/></th>
					</tr>
				</thead>
				<tbody>
					<xsl:for-each select="atom:entry">
					<tr class="wpsTableNrmRow">
						<td width="5%" class="wpsTableDataStart">
							<img width="59" height="10" border="0" align="middle">
								<xsl:choose>
									<xsl:when test="opensearch:relevance &gt; 80">
										<xsl:attribute name="src">
											<xsl:value-of select="$scoreHighestIcon"/>
										</xsl:attribute>
										<xsl:attribute name="alt">
											<xsl:value-of select="$scoreHighest"/>
										</xsl:attribute>
										<xsl:attribute name="title">
											<xsl:value-of select="$scoreHighest"/>
										</xsl:attribute>
									</xsl:when>
									<xsl:when test="opensearch:relevance &gt; 60">
										<xsl:attribute name="src">
											<xsl:value-of select="$scoreHighIcon"/>
										</xsl:attribute>
										<xsl:attribute name="alt">
											<xsl:value-of select="$scoreHigh"/>
										</xsl:attribute>
										<xsl:attribute name="title">
											<xsl:value-of select="$scoreHigh"/>
										</xsl:attribute>
									</xsl:when>
									<xsl:when test="opensearch:relevance &gt; 40">
										<xsl:attribute name="src">
											<xsl:value-of select="$scoreMediumIcon"/>
										</xsl:attribute>
										<xsl:attribute name="alt">
											<xsl:value-of select="$scoreMedium"/>
										</xsl:attribute>
										<xsl:attribute name="title">
											<xsl:value-of select="$scoreMedium"/>
										</xsl:attribute>
									</xsl:when>
									<xsl:when test="opensearch:relevance &gt; 20">
										<xsl:attribute name="src">
											<xsl:value-of select="$scoreLowIcon"/>
										</xsl:attribute>
										<xsl:attribute name="alt">
											<xsl:value-of select="$scoreLow"/>
										</xsl:attribute>
										<xsl:attribute name="title">
											<xsl:value-of select="$scoreLow"/>
										</xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="src">
											<xsl:value-of select="$scoreLowestIcon"/>
										</xsl:attribute>
										<xsl:attribute name="alt">
											<xsl:value-of select="$scoreLowest"/>
										</xsl:attribute>
										<xsl:attribute name="title">
											<xsl:value-of select="$scoreLowest"/>
										</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
							</img>
						</td>
						<td width="65%" class="wpsTableDataMiddle">
							<table width="100%" cellspacing="0" cellpadding="0">
								<tbody>
									<tr>
										<td width="22" style="border: 0pt none ; padding: 0px;">
											<img width="16" height="16" border="0" align="middle">
												<xsl:attribute name="src">
													<xsl:value-of select="opensearch:image"/>
												</xsl:attribute>
												<xsl:attribute name="title">
													<xsl:value-of select="atom:category/@label"/>
												</xsl:attribute>
												<xsl:attribute name="alt">
													<xsl:value-of select="atom:category/@label"/>
												</xsl:attribute>
											</img>
										</td>
										<td style="border: 0pt none ; padding: 0px;">
											<a>
												<xsl:attribute name="href">
													<xsl:value-of select='atom:link/@href'/>
												</xsl:attribute>
												<xsl:attribute name="type">
													<xsl:value-of select='atom:link/@type'/>
												</xsl:attribute>
												<xsl:value-of select="atom:title"/>
											</a>
										</td>
									</tr>
									<tr>
										<td style="border: 0pt none ; padding: 0px;"/>
										<td class="preFormatted ibm-portlet-item-summary" style="border: 0pt none ; padding: 0px;">
											<xsl:value-of select="atom:summary" disable-output-escaping="yes" />
										</td>
									</tr>
								</tbody>
							</table>
						</td>
						<td width="15%" class="wpsTableDataMiddle">
							<span class="vcard">
								<span class="fn"><xsl:value-of select="atom:author/atom:name"/></span>
								<xsl:if test="atom:author/atom:uri">
									<span class="uid" style="display: none;"><xsl:value-of select="atom:author/atom:uri"/></span>
								</xsl:if>
								<xsl:if test="atom:author/atom:email">
									<span class="email" style="display: none;"><xsl:value-of select="atom:author/atom:email"/></span>
								</xsl:if>
							</span>							
						</td>
						<td width="15%" class="wpsTableDataEnd">
							<div class="date">
								<xsl:value-of select="atom:updated"/>
							</div>
						</td>
					</tr>
					</xsl:for-each>
				</tbody>
			</table>
		</td>
	</tr>
	<tr>
		<td class="wpsPagingTableFooter">
			<xsl:call-template name="tableHeader">
				<xsl:with-param name="startClass">wpsPagingTableFooterStart</xsl:with-param>
				<xsl:with-param name="middleClass">wpsPagingTableFooterMiddle</xsl:with-param>
				<xsl:with-param name="endClass">wpsPagingTableFooterEnd</xsl:with-param>
				<xsl:with-param name="displayItemsPerPage">true</xsl:with-param>
			</xsl:call-template>
		</td>
	</tr>
</tbody>
</table>
</xsl:if>
</xsl:template>
<xsl:template name="tableHeader">
<xsl:param name="startClass"/>
<xsl:param name="middleClass"/>
<xsl:param name="endClass"/>
<xsl:param name="displayItemsPerPage"/>
	<table width="100%" cellspacing="0" cellpadding="3" border="0">
		<tbody>
			<tr>
				<td nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$startClass"/>
					</xsl:attribute>
					<img height="20" border="0" align="absmiddle">
						<xsl:attribute name="src">
							<xsl:value-of select="$dotIcon"/>
						</xsl:attribute>
					</img>
				</td>
				<td width="100%" valign="middle" nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$middleClass"/>
					</xsl:attribute>
					<xsl:if test="$displayItemsPerPage = 'true'">
						<table>
						<tbody>
						<tr>
							<td>
							<xsl:value-of select="$numOfResults"/>
							</td>
							<xsl:choose>
								<xsl:when test="opensearch:itemsPerPage = 10">
									<td class="itemsPerPageLink">10</td>
								</xsl:when>
								<xsl:otherwise>
									<td><a class="itemsPerPageLink" href="javascript: void(0)">10</a></td>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="opensearch:itemsPerPage = 20">
									<td class="itemsPerPageLink">20</td>
								</xsl:when>
								<xsl:otherwise>
									<td><a class="itemsPerPageLink" href="javascript: void(0)">20</a></td>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="opensearch:itemsPerPage = 30">
									<td class="itemsPerPageLink">30</td>
								</xsl:when>
								<xsl:otherwise>
									<td><a class="itemsPerPageLink" href="javascript: void(0)">30</a></td>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="opensearch:itemsPerPage = 50">
									<td class="itemsPerPageLink">50</td>
								</xsl:when>
								<xsl:otherwise>
									<td><a class="itemsPerPageLink" href="javascript: void(0)">50</a></td>
								</xsl:otherwise>
							</xsl:choose>
						</tr>
						</tbody>
						</table>
					</xsl:if>
				</td>
				<td valign="middle" nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$middleClass"/>
					</xsl:attribute>
					<xsl:if test="opensearch:startIndex &gt; 0">
					<a class="lnk1 firstPageLink" href="javascript: void(0)">
						<img border="0" align="absmiddle">
							<xsl:attribute name="src">
								<xsl:value-of select="$firstPageIcon"/>
							</xsl:attribute>
							<xsl:attribute name="alt">
								<xsl:value-of select="$firstPageText"/>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="$firstPageText"/>
							</xsl:attribute>
						</img>
					</a>
					</xsl:if>
				</td>
				<td valign="middle" nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$middleClass"/>
					</xsl:attribute>
					<xsl:if test="opensearch:startIndex &gt; 0">
					<a class="lnk1 prevPageLink" href="javascript: void(0)">
						<img border="0" align="absmiddle">
							<xsl:attribute name="src">
								<xsl:value-of select="$prevPageIcon"/>
							</xsl:attribute>
							<xsl:attribute name="alt">
								<xsl:value-of select="$prevPageText"/>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="$prevPageText"/>
							</xsl:attribute>
						</img>
					</a>
					</xsl:if>
				</td>				
				<td valign="middle" nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$middleClass"/>
					</xsl:attribute>
					<span class="showingResultsMessage"/>
				</td>
				<td valign="middle" nowrap="nowrap">
					<xsl:attribute name="class">
						<xsl:value-of select="$middleClass"/>
					</xsl:attribute>
					<xsl:if test="opensearch:totalResults &gt; opensearch:startIndex + opensearch:itemsPerPage">
					<a class="lnk1 nextPageLink" href="javascript: void(0)">
						<img border="0" align="absmiddle">
							<xsl:attribute name="src">
								<xsl:value-of select="$nextPageIcon"/>
							</xsl:attribute>
							<xsl:attribute name="alt">
								<xsl:value-of select="$nextPageText"/>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:value-of select="$nextPageText"/>
							</xsl:attribute>
						</img>
					</a>
					</xsl:if>
				</td>
				<td>
					<xsl:attribute name="class">
						<xsl:value-of select="$endClass"/>
					</xsl:attribute>
					<img border="0" align="absmiddle">
						<xsl:attribute name="src">
							<xsl:value-of select="$dotIcon"/>
						</xsl:attribute>
					</img>
				</td>
			</tr>
		</tbody>
	</table>
</xsl:template>
</xsl:stylesheet>
